//===========================================================================
//
// Real.C
//
// By Poman So
//
//===========================================================================

#include "Real.h"
void	Message(char *message, Boolean beep=False);

int iostate_;

fstream &DataIO(fstream &fs, void *data, int size){
  if (size>0){
    if (iostate_==ios::out)
      fs.write((char*)data,size);
    else
      fs.read((char*)data,size);
  }
  if (!fs) Message("DataIO failed");
  return fs;
}//--- DataIO ---//

#ifdef no_template_

fstream &operator|(fstream &fs, char &c){
  return DataIO(fs,&c,sizeof(char));
}//--- &operator| ---//


fstream &operator|(fstream &fs, int &i){
  return DataIO(fs,&i,sizeof(int));
}//--- &operator| ---//


fstream &operator|(fstream &fs, unsigned &u){
  return DataIO(fs,&u,sizeof(unsigned));
}//--- &operator| ---//


fstream &operator|(fstream &fs, Boolean &b){
  return DataIO(fs,&b,sizeof(Boolean));
}//--- &operator| ---//


fstream &operator|(fstream &fs, float &f){
  return DataIO(fs,&f,sizeof(float));
}//--- &operator| ---//


fstream &operator|(fstream &fs, double &d){
  return DataIO(fs,&d,sizeof(double));
}//--- &operator| ---//

#endif

//===========================================================================
//
// End of Real.C
//
//===========================================================================
